import os
import sys
current_dir = os.path.dirname(__file__)
parent_dir = os.path.abspath(os.path.join(current_dir, '..'))
sys.path.append(parent_dir)
from data_structs import Measurement, Sensor, MarkerTemplate, DateAndTime
from flask import json

# get_markers parses a list of MarkerTemplate objects to json, and returns either a successfully
# parsed json object with status code 200, or and error message and status code 501
def get_markers():
    try:
        # NB: temporary test data
        sensor1 = Sensor(ID=1, type="Type1", active=True)
        sensor2 = Sensor(ID=2, type="Type2", active=False)

        datetime1 = DateAndTime(2023, 12, 31, 15, 43)
        datetime2 = DateAndTime(2024, 1, 15, 12, 2)
        datetime3 = DateAndTime(2024, 1, 31, 18, 10)

        measurement1 = Measurement(longitude=10.9771, latitude=60.7066, datetime=datetime1, sensor=sensor1, 
                                   precipitation=0.0, thickness=0.0, max_weight=0.0, safety_level=0.0, accuracy=2.5)
        measurement2 = Measurement(longitude=10.8171, latitude=60.6366, datetime=datetime2, sensor=sensor2, 
                                   precipitation=0.0, thickness=0.0, max_weight=0.0, safety_level=0.0, accuracy=1.5)
        measurement3 = Measurement(longitude=10.8471, latitude=60.7366, datetime=datetime3, sensor=sensor1, 
                                   precipitation=0.0, thickness=0.0, max_weight=0.0, safety_level=0.0, accuracy=4.0)
    
        testData = [
            MarkerTemplate(measurement1, 30.0-measurement1.accuracy, "Green"),
            MarkerTemplate(measurement2, 10.0-measurement2.accuracy, "Red"),
            MarkerTemplate(measurement3, 20.0-measurement3.accuracy, "Yellow"),
        ]
        
        # NB: return test data as JSON
        return json.dumps([marker.to_dict() for marker in testData]), 200
    
    except Exception as e:
        return e, 500